Adding update, usage and options to tmdb

This commit is contained in:
Alex Epstein 2017-08-02 14:32:07 -04:00
parent bbeaeda4b7
commit 527f24f24d
1 changed files with 80 additions and 7 deletions

View File

@ -62,6 +62,47 @@ checkInternet()
httpGet github.com > /dev/null 2>&1 || { echo "Error: no active internet connection" >&2; return 1; } # query github with a get request
}
update()
{
# Author: Alexander Epstein https://github.com/alexanderepstein
# Update utility version 1.2.0
# To test the tool enter in the defualt values that are in the examples for each variable
repositoryName="Bash-Snippets" #Name of repostiory to be updated ex. Sandman-Lite
githubUserName="alexanderepstein" #username that hosts the repostiory ex. alexanderepstein
nameOfInstallFile="install.sh" # change this if the installer file has a different name be sure to include file extension if there is one
latestVersion=$(httpGet https://api.github.com/repos/$githubUserName/$repositoryName/tags | grep -Eo '"name":.*?[^\\]",'| head -1 | grep -Eo "[0-9.]+" ) #always grabs the tag without the v option
if [[ $currentVersion == "" || $repositoryName == "" || $githubUserName == "" || $nameOfInstallFile == "" ]]; then
echo "Error: update utility has not been configured correctly." >&2
exit 1
elif [[ $latestVersion == "" ]];then
echo "Error: no active internet connection" >&2
exit 1
else
if [[ "$latestVersion" != "$currentVersion" ]]; then
echo "Version $latestVersion available"
echo -n "Do you wish to update $repositoryName [Y/n]: "
read -r answer
if [[ "$answer" == [Yy] ]]; then
cd ~ || { echo 'Update Failed' ; exit 1; }
if [[ -d ~/$repositoryName ]]; then rm -r -f $repositoryName || { echo "Permissions Error: try running the update as sudo"; exit 1; } ; fi
git clone "https://github.com/$githubUserName/$repositoryName" || { echo "Couldn't download latest version" ; exit 1; }
cd $repositoryName || { echo 'Update Failed' ; exit 1; }
git checkout "v$latestVersion" 2> /dev/null || git checkout "$latestVersion" 2> /dev/null || echo "Couldn't git checkout to stable release, updating to latest commit."
chmod a+x install.sh #this might be necessary in your case but wasnt in mine.
./$nameOfInstallFile "update" || exit 1
cd ..
rm -r -f $repositoryName || { echo "Permissions Error: update succesfull but cannot delete temp files located at ~/$repositoryName delete this directory with sudo"; exit 1; }
else
exit 1
fi
else
echo "$repositoryName is already the latest version"
fi
fi
}
printMovieInfo()
{
echo
@ -76,6 +117,21 @@ printMovieInfo()
echo
}
usage()
{
cat <<EOF
Movies
Description: Provides relevant information about a certain movie.
Usage: movies [flag] or movies [movieToSearch]
-u Update Bash-Snippet Tools
-h Show the help
-v Get the tool version
Examples:
movies Argo
movies Inception
EOF
}
getMovieInfo()
{
title=$1
@ -100,11 +156,28 @@ getConfiguredClient || exit 1
if [[ "$(uname)" == "Linux" ]];then getConfiguredPython || exit 1; fi
checkInternet || exit 1
if [ "$1" == "-h" ]; then
usage
exit 0
fi
args=$(echo "$@")
getMovieInfo $args
printMovieInfo
while getopts 'uhv' flag; do
case "${flag}" in
u) update
exit 0 ;;
h) usage
exit 0 ;;
v) echo "Version $currentVersion"
exit 0 ;;
:) echo "Option -$OPTARG requires an argument." >&2
exit 1 ;;
*) exit 1 ;;
esac
done
if [[ $# == 0 ]]; then
usage
elif [[ $1 == "update" ]]; then
update
elif [[ $1 == "help" ]]; then
usage
else
getMovieInfo "$@" || exit 1 ## exit if we return 1 (chances are movie was not found)
printMovieInfo ## print out the data
fi